zombies.safezones = { {47,79, 63,98}, {76,29, 91,44}, {4,0, 28,13}, {42,32, 47,35} } -- Safe zones (no damage, safe from solar flares)
zombies.cover = { {47,82, 63,98}, {48,70, 55,73}, {16,66, 41,73}, {16,51, 21,62}, {60,65, 66,73}, {71,65, 80,73}, {76,29, 91,44}, {4,0, 28,13}, {42,32, 47,35} } -- Cover (safe from solar flares)

towns.plots = { {2,82,15,94} }

--- ACTIONS ---

zombies.addAction(51,90,function(id) zombies.addThirst(id,10) end)

--- NPCS ---

customnpcs.createNPC("Medic",48,83,135)
customnpcs.setAction(1,"trade",32)
customnpcs.addTrade(1,{{101,1}},{{1,1}})
customnpcs.addTrade(1,{{101,2}},{{2,1}})
customnpcs.addTrade(1,{{101,4}},{{3,1}})

customnpcs.createNPC("Information",54,88,180)
customnpcs.setAction(2,"talk",48)
customnpcs.addLine(2,0,"Hello",{"There's lots of things to do out here."},{1})
customnpcs.addLine(2,1,"Like what?",{"Well, first and foremost - you can, and need, to kill zombies.","They carry many useful resources, without which this base would have fallen long ago.","You can also explore the Wastelands and search for abandoned or stashed goods.","Some zombies drop coins, which you can use back here to buy provisions and other goods.","Don't forget to eat, drink and sleep!","Now, go out there and explore!"},{})

customnpcs.createNPC("Provisions",50,83,180)
customnpcs.setAction(3,"trade",48)
customnpcs.addTrade(3,{{101,1}},{{4,1}})
customnpcs.addTrade(3,{{101,1}},{{5,1}})

customnpcs.createNPC("Money Changer",48,87,45)
customnpcs.setAction(4,"trade",48)
customnpcs.addTrade(4,{{101,10}},{{102,1}})
customnpcs.addTrade(4,{{102,1}},{{101,10}})
customnpcs.addTrade(4,{{102,10}},{{103,1}})
customnpcs.addTrade(4,{{103,1}},{{102,10}})

customnpcs.createNPC("Oven",58,83,0,"gfx/customnpcs/cooker.bmp")
customnpcs.setAction(5,"trade",32)
customnpcs.addTrade(5,{{6,1}},{{7,1}})
customnpcs.addTrade(5,{{8,1}},{{9,1}})

customnpcs.createNPC("Scientist",82,34,315,"gfx/customnpcs/npc4.png")
customnpcs.setAction(6,"trade",32)
customnpcs.addTrade(6,{{101,1},{6,1}},{{8,1}})

customnpcs.createNPC("Furnace",58,87,0,"gfx/customnpcs/cooker.bmp")
customnpcs.setAction(7,"trade",32)
customnpcs.addTrade(7,{{15,5}},{{17,1}})
customnpcs.addTrade(7,{{14,1}},{{17,1}})
customnpcs.addTrade(7,{{16,1}},{{17,1}})
customnpcs.addTrade(7,{{17,1}},{{14,1}})
customnpcs.addTrade(7,{{17,1}},{{13,1}})
customnpcs.addTrade(7,{{10,5}},{{15,1}})

customnpcs.createNPC("Worker",60,84,180,"gfx/customnpcs/npc11.png")
customnpcs.setAction(8,"talk",48)
customnpcs.addLine(8,0,"Hello.",{"Welcome to the factory!"},{1,2})
customnpcs.addLine(8,1,"What is this place?",{"This factory produces materials - metal, concrete, that sort of thing.","Here we make the stuff that holds this base together!"},{0})
customnpcs.addLine(8,2,"Can I use the equipment here?",{"Sure, as long as you don't break it."},{})

customnpcs.createNPC("Survivor",46,33,270)
customnpcs.setAction(9,"trade",48)
customnpcs.addTrade(9,{{4,1}},{{101,1}})
customnpcs.addTrade(9,{{5,1}},{{101,1}})
customnpcs.addTrade(9,{{8,1}},{{101,2}})
customnpcs.addTrade(9,{{9,1}},{{101,2}})

customnpcs.createNPC("Weapons",52,85,270)
customnpcs.setAction(10,"trade",48)
customnpcs.addTrade(10,{{101,7}},{{"cs2d:1",1}})
customnpcs.addTrade(10,{{101,7}},{{"cs2d:2",1}})
customnpcs.addTrade(10,{{101,16}},{{"cs2d:10",1}})
customnpcs.addTrade(10,{{101,18}},{{"cs2d:11",1}})
customnpcs.addTrade(10,{{102,3}},{{"cs2d:32",1}})
customnpcs.addTrade(10,{{102,4}},{{"cs2d:35",1}})
customnpcs.addTrade(10,{{101,3}},{{"cs2d:61",1}})
customnpcs.addTrade(10,{{101,2}},{{"cs2d:62",1}})


--- CHESTS ---

chests.newChest{
	pos = {55*32,70*32+16},
	contents = {{1,1},{4,2},{5,1},{101,1}},
	reset = 120,
}


--- BEDS ---

zombies.createBed(58*32+16,92*32+32,32,16)
zombies.createBed(60*32+16,92*32+32,32,16)
zombies.createBed(62*32+16,92*32+32,32,16)
zombies.createBed(58*32+16,96*32+32,32,16)
zombies.createBed(60*32+16,96*32+32,32,16)
zombies.createBed(62*32+16,96*32+32,32,16)
zombies.createBed(15*32+16,9*32+32,32,16)
zombies.createBed(17*32+16,9*32+32,32,16)
zombies.createBed(19*32+16,9*32+32,32,16)

--- MINING ---

mining.createMining {
	pos = {63, 42},
	size = {3, 4},
	
	items = {
		{ {{10, 1}}, 20 },
		{ {{13, 1}}, 10 },
		{ {{14, 1}}, 30 },
		{ {{15, 1}}, 50 },
		{ {{16, 1}}, 5 },
		{ {{17, 1}}, 35 },
	},
	
	interval = 10
}