chests = {}
chests.internal = {}

function chests.internal.load(c)
	local fh=io.open("sys/lua/zombies/saves/chests/chest"..c..".sav","r")
	if fh then
		chests[c][4] = loadstring("return "..fh:read("*a"))()
		fh:close()
	end
end

function chests.internal.save(cid)
	local fh=io.open("sys/lua/zombies/saves/chests/chest"..cid..".sav","w")
	local c=chests[cid]
	
	fh:write("{")
	if c[6]~="private" then
		for _,i in pairs(c[4]) do
			fh:write("\n\t{"..i[1])
			if i[2] then
				fh:write(","..i[2])
			end
			fh:write("},")
		end
	else
		for i=1,32 do
			fh:write("\n\t{")
			for _,s in pairs(c[4][i]) do
				fh:write("\n\t\t{"..s[1])
				if s[2] then
					fh:write(","..s[2])
				end
				fh:write("},")
			end
			fh:write("\n\t},")
		end
	end
	
	fh:write("\n}")
	fh:close()
end

function chests.internal.resetChest(chest)
	if mode=="private" then
		for i=1,32 do
			chests[chest][4]=table.copy(chests[chest][11])
		end
	else
		chests[chest][4]=table.copy(chests[chest][11])
	end
	if (chests[chest][12]~=0) then
		timer(chests[chest][12]*1000,"parse","lua chests.internal.resetChest("..#chests..")")
	end
end

function chests.newChest(args)
	local x,y = (args.pos and args.pos[1]) or (args.x) or 0, (args.pos and args.pos[2]) or (args.y) or 0
	local contents = args.contents
	local img = args.img or "gfx/customnpcs/chest.png"
	local rot = args.rot or 0
	local actrad = args.actrad or 64
	local mode = args.mode or public
	local owner = args.ower or 0
	local name = args.name or "Chest"
	local limit = args.limit or 9001
	local resettime = args.reset or 0
	
	local cimg=image(img,0,0,0)
	imagepos(cimg,x,y,rot)
	local inv
	if mode=="private" then
		inv={}
		for i=1,32 do
			inv[i]=contents
		end
	else
		inv=contents
	end
	chests[#chests+1]={x,y,name or "Chest",inv,limit or 9001,mode or "public",owner or 0,cimg,actrad,img,contents,resettime}
	if (resettime~=0) then
		timer(resettime*1000,"parse","lua chests.internal.resetChest("..#chests..")")
	end
end

local tempchest,tempitem
local function take(id,c,i,n)
	local mode=chests[c][6]
	local taken
	if mode~="private" then
		taken=items.addToInventory(id,i,n)
		chests.removeItem(c,i,n)
	else
		taken=items.addToInventory(id,i,n)
		chests.removePrivateItem(c,i,n)
	end
	if not taken then
		msg2(id,"Your inventory is full.")
	end
	if chests[c].update and chests[c].update.take then
		chests[cid].update.take(c,i,n)
	end
	chests.internal.save(c)
	chests.open(id,c)
end

addhook("menu","chests.internal.menu")
function chests.internal.menu(id,menu,sel)
	if menu=="Amount" then
		if sel==1 then
			take(id,tempchest,tempitem,1)
		end
		if sel==2 then
			take(id,tempchest,tempitem,2)
		end
		if sel==3 then
			take(id,tempchest,tempitem,5)
		end
		if sel==4 then
			take(id,tempchest,tempitem,10)
		end
		if sel==5 then
			take(id,tempchest,tempitem,chest.allItem(tempchest,tempitem))
		end
	end
end

function chests.open(id,cid)
	local c=chests[cid]
	local name=c[3]
	local inv={}
	local function selmenu(id,item)
		tempchest=item[5]
		tempitem=item[4]
		menu(id,"Amount,1,2,5,10,All")
	end
	if c[6]=="public" then
		for _,i in pairs(c[4]) do
			inv[_]={items[i[1]][1],items[i[1]][2],selmenu,i[1],cid}
			if i[2] and i[2]>1 then
				inv[_][1]=inv[_][1].." ("..i[2]..")"
			end
		end
	elseif c[6]=="protected" and c[7]==id or c[7]==0 then
		for _,i in pairs(c[4]) do
			inv[_]={items[i[1]][1],items[i[1]][2],selmenu,i[1],cid}
			if i[2] and i[2]>1 then
				inv[_][1]=inv[_][1].." ("..i[2]..")"
			end
		end
	elseif c[6]=="private" then
		for _,i in pairs(c[4][id]) do
			inv[_]={items[i[1]][1],items[i[1]][2],selmenu,i[1],cid}
			if i[2] and i[2]>1 then
				inv[_][1]=inv[_][1].." ("..i[2]..")"
			end
		end
	end
	unimenu(id,true,{title=name,items=inv},1)
end

function chests.occupied(id)
	local nf=0
	for _,i in pairs(chests[id][4]) do
		if i[1]~=0 then nf=nf+1 end
	end
	return nf
end

function chests.occupiedPrivate(id,pid)
	local nf=0
	for _,i in pairs(chests[id][4]) do
		if i[1]~=0 then nf=nf+1 end
	end
	return nf
end

function chests.allItem(id,iid)
	local i=0
	for _,i in pairs(chests[id][4]) do
		if i[1]==iid then i=i+1 end
	end
	return i
end

function chests.allPrivateItem(id,iid,pid)
	local i=0
	for _,i in pairs(chests[id][4][pid]) do
		if i[1]==iid then i=i+1 end
	end
	return i
end

function chests.freeSlots(id)
	local fs=0
	if chests.occupied(id)<chests[id][5] then
		for _,i in pairs(chests[id][4]) do
			if i[1]==0 then fs=fs+1 end
		end
	end
	return fs
end

function chests.freePrivateSlots(id,pid)
	local fs=0
	if chests.occupied(id)<chests[id][5] then
		for _,i in pairs(chests[id][4][pid]) do
			if i[1]==0 then fs=fs+1 end
		end
	end
	return fs
end

function chests.freeSlot(id)
	if chests.occupied(id)<chests[id][5] then
		for _,i in pairs(chests[id][4]) do
			if i[1]==0 then return _ end
		end
	end
	return nil
end

function chests.freePrivateSlot(id,pid)
	if chests.occupied(id)<chests[id][5] then
		for _,i in pairs(chests[id][4][pid]) do
			if i[1]==0 then return _ end
		end
	end
	return nil
end

function chests.addItem(id,iid,n)	
	n=n or 1
	local c=chests[id]
	for _,i in pairs(c[4]) do
		if i[1]==iid and i[2] and items[iid][4] and (items[iid][5] and i[2]+n<=items[iid][5] or true) then
			c[4][_][2]=c[4][_][2]+n
			chests.internal.save(id)
			return true
		end
	end
	
	--else
	
	local fs=chests.freeSlots(id)
	if n>1 and fs>=1 and items[iid][4] then
		if items[iid][5]>=n then
			local slot=chests.freeSlot(id)
			c[4][slot]={iid,n}
			chests.internal.save(id)
			return true
		else
			local slot=chests.freeSlot(id)
			c[4][slot]={iid,items[iid][5]}
			chests.addItem(id,iid,n-items[iid][5])
			chests.internal.save(id)
		end
	end 
	if fs>=n then
		for i=1,n do
			local slot=chests.freeSlot(id)
			if slot then
				c[4][slot]={iid}
				if items[iid][4] then
					c[4][slot][2]=1
				end
				chests.internal.save(id)
			else
				return false
			end
		end
		return true
	else
		return false
	end
	
	return false
end

function chests.addPrivateItem(id,iid,n,pid)	
	n=n or 1
	local c=chests[id][pid]
	for _,i in pairs(c[4]) do
		if i[1]==iid and i[2] and items[iid][4] and (items[iid][5] and i[2]+n<=items[iid][5] or true) then
			c[4][_][2]=c[4][_][2]+n
			chests.internal.save(id)
			return true
		end
	end
	
	--else
	
	local fs=chests.freeSlots(id)
	if n>1 and fs>=1 and items[iid][4] then
		if items[iid][5]>=n then
			local slot=chests.freeSlot(id)
			c[4][slot]={iid,n}
			chests.internal.save(id)
			return true
		else
			local slot=chests.freeSlot(id)
			c[4][slot]={iid,items[iid][5]}
			chests.addItem(id,iid,n-items[iid][5])
			chests.internal.save(id)
		end
	end 
	if fs>=n then
		for i=1,n do
			local slot=chests.freeSlot(id)
			if slot then
				c[4][slot]={iid}
				if items[iid][4] then
					c[4][slot][2]=1
				end
				chests.internal.save(id)
			else
				return false
			end
		end
		return true
	else
		return false
	end
	
	return false
end

function chests.removeSlot(id,slot)
	chests[id][4][slot]={0}
end

function chests.removePrivateSlot(id,slot,pid)
	chests[id][4][pid][slot]={0}
end

function chests.removeItem(id,iid,n)
	n=n or 1
	local c=chests[id]
	for _,i in ipairs(c[4]) do
		if i[1]==iid then
			if i[2] then
				if i[2]>n then
					c[4][_][2]=c[4][_][2]-n
					return true
				else
					c[4][_]={0}
					if n-i[2]>0 then
						return chests.removeItem(id,iid,n-i[2])
					else
						return true
					end
				end
			else
				for i=1,n do
					chests.removeItem(id,iid)
				end
				return true
			end
		end
	end
	return false
end

function chests.removePrivateItem(id,iid,n,pid)
	n=n or 1
	local c=chests[id][pid]
	for _,i in ipairs(c[4]) do
		if i[1]==iid then
			if i[2] then
				if i[2]>n then
					c[4][_][2]=c[4][_][2]-n
					return true
				else
					c[4][_]={0}
					if n-i[2]>0 then
						return chests.removeItem(id,iid,n-i[2])
					else
						return true
					end
				end
			else
				for i=1,n do
					chests.removeItem(id,iid)
				end
				return true
			end
		end
	end
	return false
end

function chests.setUpdate(cid,event,func)
	if not chests[cid].update then chests[cid].update = {} end
	chests[cid].update[event]=func
end

function chests.nearChest(id)
	for cid, c in ipairs(chests) do
		local d = math.sqrt((c[1]-player(id,"x"))^2+(c[2]-player(id,"y"))^2)
		if d<=c[9] then
			return cid
		end
	end
	return false
end

addhook("use","chests.internal.use")
function chests.internal.use(id)
	local x,y=player(id,"x"),player(id,"y")
	for _,c in ipairs(chests) do
		local d=math.sqrt((x-c[1])^2+(y-c[2])^2)
		if d<=c[9] then
			chests.open(id,_)
		end
	end
end