--------------- CUSTOMIZATION VALUES ---------------

zombies.admins = { 7749 } -- List of administrators

zombies.mapamount = 250 -- Highest amount of enemies allowed to be on the map

--[[
Zones are specified as rectangles in the format {upperleftx,upperlefty,bottomrightx,bottomrighty}. Positions in tiles.
]]

zombies.maxhunger = 100 -- Highest value of hunger
zombies.maxthirst = 100 -- Highest value of thirst
zombies.maxfatigue = 100 -- Highest value of fatigue (tiredness)
zombies.maxhealth = 100 -- Highest health value

zombies.buffhudoffset = 19 -- Offset for buff HUD text

-- Drops for each NPC type. {percent,itemid,amount}
zombies.drops = {
	[1] = {{50,101,1},{20,101,1},{5,101,2}},
	[2] = {{50,6,1}},
	[3] = {{50,6,1}},
	[5] = {{50,102,1},{30,2,1}},
}

zombies.spawnchances = {{60,1},{10,1},{25,2}} -- How likely it is for different NPCs to spawn. {percent,npctype}
--zombies.spawnchances = {{100,1},{100,1},{100,1},{100,1},{100,1},{100,1},{100,1},{100,1},{100,1},{100,1}} -- How likely it is for different NPCs to spawn. {percent,npctype} (uncomment for stress test, will spawn 10 zombies each second)

-- Ranks. {zombiekills,name,chatsuffix}
zombies.ranks = {
	{0,"Cadet"," "..string.char(169).."155000000[Cdt]"},
	{10,"Private"," "..string.char(169).."000255255[Pte]"},
	{20,"Lance Corporal"," "..string.char(169).."255255000[LCpl]"},
	{50,"Corporal"," "..string.char(169).."255000000[Cpl]"},
	{100,"Sergeant"," "..string.char(169).."200200200[Sgt]"},
	{150,"Colour Sergeant"," "..string.char(169).."000255000[CSgt]"},
	{200,"Second Lieutenant"," "..string.char(169).."000000255[2Lt]"},
	{250,"Lieutenant"," "..string.char(169).."000000255[Lt]"},
	{300,"Captain"," "..string.char(169).."000000255[Capt]"},
	{400,"Major"," "..string.char(169).."000000255[Maj]"},
	{500,"Lieutenant-Colonel"," "..string.char(169).."255255255[Lt Col]"},
	{600,"Colonel"," "..string.char(169).."255255255[Col]"},
	{750,"Brigadier"," "..string.char(169).."255255255[Brig]"},
	{1000,"Major-General"," "..string.char(169).."255215000[Maj Gen]"},
	{1500,"Lieutenant-General"," "..string.char(169).."255215000[Lt Gen]"},
	{2000,"General"," "..string.char(169).."255215000[Gen]"},
}

-- Drainage

zombies.statspertile = {-0.08,-0.09,-0.1} -- Hunger, thirst and fatigue added per one tile moved
zombies.statsperatk  = {-0.07,-0.09,-0.1} -- Hunger, thirst and fatigue added per one attack
zombies.statsperhit  = {-0.2,-0.25,-0.25} -- Hunger, thirst and fatigue added per one hit
zombies.statspersec  = {-0.05,-0.075,-0.05} -- Hunger, thirst and fatigue added per one second
zombies.statsperssz  = {0,0,0} -- Hunger, thirst and fatigue added per one second inside a safe zone
zombies.statspersib  = {-0.2,-0.2,2} -- Hunger, thirst and fatigue added per one second in a bed

zombies.statsperrad  = {-0.009,-0.009,-0.009,-0.017} -- Hunger, thirst, fatigue and health added per rad point per second

--[[
Defence added per one point of hunger, thirst and fatigue.
The points are added up to receive a final number.

(0 - absorb no damage, 1 - absorb all damage)
]]
zombies.defperstat = {0.003,0.003,0.003}
zombies.dmgthreshold = {30,30,30} -- Points of hunger, thirst and fatigue, below which the player takes damage.
zombies.dmgperstatsec = {0.066666667,0.066666667,0.066666667} -- Points of pure damage taken per stat per second
zombies.regthreshold = {80,80,80} -- Points of hunger, thirst and fatigue, above which the player regenerates health.
zombies.regperstatsec = {0.066666667,0.066666667,0.066666667} -- Points of health regenerated per stat per second

--[[
Maximum R and G colour for the stat text indicators.

An indicator will be of colour rgb(X,0,0) when its stat is at 0, rgb(0,X,0) when its stat is at its maximum, rgb(X/2,X/2,0) when its stat is half of the maximum.
]]
zombies.maxindcolour = 200

zombies.flashchance = 50 -- Chance of a solar flare
zombies.flashtime = 60 -- Period of solar flares
zombies.flashdamage = 20 -- Damage dealt by solar flares (absorbable)

zombies.townprice = {{102,20}} -- Items needed as payment to claim a plot
zombies.buildingprice = {
	[1] = {{11,4},{101,1}}, -- Barricade
	[2] = {{16,1},{101,1}}, -- Barbed Wire
	[3] = {{12,1},{101,1}}, -- Wall I
	[4] = {{12,1},{13,1},{101,1}}, -- Wall II
	[5] = {{12,1},{13,2},{17,1},{101,1}}, -- Wall III
}

zombies.radmultarmor = {
	[0] = 1,
	[201] = 0.5,
	[202] = 0.25,
}

crafting.displayunlearnt = true -- Display all recipes, including those the player didn't learn
crafting.successchance = 70 -- Default success rate of recipes if one is not specified

items.defaultlimit = 40
items.starterkit = {}

towns.townrank = 8


--------------- GLOBAL ITEMS & STUFF ---------------


--- BUFFS ---

zombies.createBuff(1,"Sated",{add=function(id) msg2(id,"You feel sated.") end,second=function(id) zombies.addHunger(id,0.5) end})
zombies.createBuff(2,"Radiation Protection",{add=function(id) msg2(id,"You get radiation protection.") end,second=function(id) zombies.players[player(id,"usgn")].radspersec = zombies.players[player(id,"usgn")].radspersec/2 end})


--- ITEMS ---

-- UTILITY --

-- Healing and Protection

items.addItem(1,"Bandage","Apply directly to wound. Heals 5 points.",function(id,item) zombies.addHealth(id,5) items.removeItem(id,1) items.openInventory(id) end,true,5)
items.addItem(2,"Medpack","Heals 10 points.",function(id,item) zombies.addHealth(id,10) items.removeItem(id,2) items.openInventory(id) end,false)
items.addItem(3,"Rapid Healing Serum","Heals 20 points.",function(id,item) zombies.addHealth(id,20) items.removeItem(id,3) items.openInventory(id) end,false)
items.addItem(18,"Radiation Treatment","Removes 5 points of radiation.",function(id,item) zombies.addRadiation(id,-5) items.removeItem(id,18) items.openInventory(id) end,false)
items.addItem(19,"Anti-Rad","Reduces radiation per second twofold for 60 seconds.",function(id,item) zombies.addBuff(id,2,60) items.removeItem(id,19) items.openInventory(id) end,false)
items.addItem(22,"Radiation Suit","Reduces radiation per second twofold.",function(id,item)
	if (zombies.players[player(id,"usgn")].armour~=0) then
		local tbl={[201]=22,[202]=23}
		for k,v in pairs(tbl) do
			if zombies.players[player(id,"usgn")].armour==k then
				if items.addItem(id,v,1) then
					parse("setarmor "..id.." 201")
					zombies.players[player(id,"usgn")].armour=201
					items.removeItem(id,22)
					items.openInventory(id)
				else
					msg2(id,"You don't have enough inventory space to take off your current radiation suit.")
				end
			end
		end
	end
end,false)
items.addItem(23,"Enhanced Radiation Suit","Reduces radiation per second fourfold.",function(id,item)
	if (zombies.players[player(id,"usgn")].armour~=0) then
		local tbl={[201]=22,[202]=23}
		for k,v in pairs(tbl) do
			if zombies.players[player(id,"usgn")].armour==k then
				if items.addItem(id,v,1) then
					parse("setarmor "..id.." 202")
					zombies.players[player(id,"usgn")].armour=202
					items.removeItem(id,23)
					items.openInventory(id)
				else
					msg2(id,"You don't have enough inventory space to take off your current radiation suit.")
				end
			end
		end
	end
end,false)

-- Provisions

items.addItem(4,"Canned Food","Says 'SPAM' on the label. Restores 10 hunger.",function(id,item) zombies.addHunger(id,10) zombies.addThirst(id,-2) items.removeItem(id,4) items.openInventory(id) end,false)
items.addItem(5,"Dirty Water","It's kind of murky. Restores 10 thirst.",function(id,item) zombies.addThirst(id,10) zombies.addHealth(id,-1) zombies.addRadiation(id,2) items.removeItem(id,5) items.openInventory(id) end,false)
items.addItem(6,"Irradiated Meat","The Geiger counter ticks a little. Restores 5 hunger.",function(id,item) zombies.addHunger(id,5) zombies.addThirst(id,-1) zombies.addHealth(id,-2) zombies.addRadiation(id,2) items.removeItem(id,6) items.openInventory(id) end,true)
items.addItem(7,"Irradiated Steak","It's still got rads - but it's cooked. Restores 10 hunger.",function(id,item) zombies.addHunger(id,10) zombies.addThirst(id,-2) zombies.addHealth(id,-1) zombies.addRadiation(id,1) items.removeItem(id,7) items.openInventory(id) end,true)
items.addItem(8,"Meat","Clean raw meat. Restores 5 hunger.",function(id,item) zombies.addHunger(id,5) zombies.addThirst(id,-1) zombies.addHealth(id,-1) items.removeItem(id,8) items.openInventory(id) end,true)
items.addItem(9,"Steak","Lovely fried meat. Restores 10 hunger.",function(id,item) zombies.addHunger(id,10) zombies.addThirst(id,-2) zombies.addBuff(id,1,10) items.removeItem(id,9) items.openInventory(id) end,true)

-- Mats

items.addItem(10,"Tin Can","An empty tin can.",function() end,true)
items.addItem(11,"Sandbag","A bag full of sand.",function() end,true)
items.addItem(12,"Concrete Panel","A panel of concrete.",function() end,true)
items.addItem(13,"Rebar","Steel reinforcing bars.",function() end,true)
items.addItem(14,"Metal Wire","A roll of steel wire.",function() end,true)
items.addItem(15,"Scrap Metal","Bits and pieces; nuts and bolts.",function() end,true)
items.addItem(16,"Barbed Wire","A roll of steel barbed wire.",function() end,true)
items.addItem(17,"Metal Plating","A plate of metal.",function() end,true)
items.addItem(20,"Copper Scrap","Scrapes and bits of mostly copper.",function() end,true)
items.addItem(21,"Tin Scrap","Scrapes and bits of mostly tin.",function() end,true)


-- CURRENCY --

items.addItem(101,"Bronze Coin","A roughly disk-shaped bronze nugget used universally as currency.",function() end,true)
items.addItem(102,"Iron Coin","A roughly disk-shaped iron nugget used universally as currency.",function() end,true)
items.addItem(103,"Gold Coin","A roughly disk-shaped golden nugget used universally as currency.",function() end,true)
items.addItem(104,"Diamond Coin","A rough diamond used universally as currency.",function() end,true)


-- RECIPES --

items.addItem(201,"Steak","Lovely fried meat. Restores 10 hunger.",function(id,item) zombies.addHunger(id,10) zombies.addThirst(id,-2) items.removeItem(id,9) items.openInventory(id) end,true)


--- CRAFTING ---

crafting.createRecipe({{4,1}},{{10,1},{8,1}},true)
crafting.createRecipe({{16,1}},{{14,1},{15,3}},true)


--- MONSTERS ---

monsters.createArchetype(1,{health=100,image="gfx/customnpcs/zombie.png",hzox=16,hzoy=16,speed=64,behav="attack+roam",reactdist=256,atktime=1,atkdist=16,dmgfunc=zombies.damage,killfunc=zombies.killZombie,dmg=20,minroam=1,maxroam=3,nosafe=true})
monsters.createArchetype(2,{health=20,image="gfx/npc/headcrab.bmp<m>",hzox=16,hzoy=16,speed=196,behav="attack+roam",reactdist=256,atktime=1,atkdist=16,dmgfunc=zombies.damage,killfunc=zombies.killZombie,dmg=5,minroam=1,maxroam=3,nosafe=true})

for c,_ in ipairs(chests) do
	chests.internal.load(c)
end