dofile("sys/lua/zombies/unimenu.lua")

customnpcs = {}
customnpcs.internal = {}
customnpcs.hudtxtid = 0

function customnpcs.createNPC(name,x,y,rot,imgpath)
	customnpcs[#customnpcs+1]={name=name,x=x,y=y,rot=rot,img=(imgpath and image(imgpath,0,0,1) or image("gfx/customnpcs/npc1.png",0,0,1)),imgpath=imgpath}
	imagepos(customnpcs[#customnpcs].img,x*32+16,y*32+16,rot)
end

addhook("startround","customnpcs.internal.redraw")
function customnpcs.internal.redraw()
	for n, npc in ipairs(customnpcs) do
		customnpcs[n].img = npc.imgpath and image(npc.imgpath,0,0,1) or image("gfx/customnpcs/npc1.png",0,0,1)
		imagepos(customnpcs[n].img,npc.x*32+16,npc.y*32+16,npc.rot)
	end
end

addhook("always","customnpcs.internal.update")
function customnpcs.internal.update()
	for _,npc in ipairs(customnpcs) do
		for __,id in pairs(player(0,"table")) do
			parse("hudtxt2 "..id.." "..customnpcs.hudtxtid+_.." \""..npc.name.."\" "..(320-(player(id,"x")-(npc.x*32+16))).." "..(240-(player(id,"y")-(npc.y*32))).." 1")
		end
	end
end

function customnpcs.setAction(npc,action,actionradius)
	customnpcs[npc].action = action
	customnpcs[npc].actionradius = actionradius
	if action=="trade" then
		customnpcs[npc].trade = {}
	end
	if action=="talk" then
		customnpcs[npc].lines = {}
	end
end

function customnpcs.addTrade(npc,givet,taket)
	local give,giveamount=unpack(givet)
	local take,takeamount=unpack(taket)
	customnpcs[npc].trade[#customnpcs[npc].trade+1]={givet,taket}
end

function customnpcs.addLine(npc,lid,lname,lines,next)
	customnpcs[npc].lines[lid]={lname,lines,next}
end

function customnpcs.addBehaviour(npc,behav,radius) -- NOT IMPLEMENTED YET
	if not customnpcs[npc].behaviours then customnpcs[npc].behaviours={} end
	customnpcs[npc].behaviours[#customnpcs[npc].behaviours+1] = {behav,radius}
end

function customnpcs.internal.action(id,npc)
	local enpc=customnpcs[npc]
	if enpc.action=="trade" then
		local tritems={}
		for _,bar in pairs(customnpcs[npc].trade) do
			local function trade(id,item)
				local fs = items.freeInInventory(id)
				local ts = 0
				for _,t in pairs(bar[2]) do
					ts=ts+t[2]
				end
				if fs>=ts then
					if items.takeItems(id,bar[1]) then
						if items.giveItems(id,bar[2]) then
							msg2(id,"Trade successful!")
						end
					else
						msg2(id,"Trade failed! You do not have enough to pay.")
					end
				else
					msg2(id,"Trade failed! You don't have enough space.")
				end
				unimenu(id,"old")
			end
			--local tradetext = ""
			--for _,t in pairs(bar[1]) do
			--	tradetext = tradetext..t[2].." of "..items[t[1]][1]
			--	if _~=#bar[1] then
			--		tradetext = tradetext.." and "
			--	end
			--end
			tradetext=items.itemList(bar[1]).." for "..items.itemList(bar[2])
			--tradetext = tradetext.." for "
			--for _,t in pairs(bar[2]) do
			--	tradetext = tradetext..t[2].." of "..items[t[1]][1]
			--	if _<#bar[2] then
			--		tradetext = tradetext.." and "
			--	end
			--end
			tritems[#tritems+1]={tradetext,"",trade,bar[1],bar[2]}
		end
		unimenu(id,true,{title="Trade with "..customnpcs[npc].name,items=tritems},1)
	end
	--modifiers
	if enpc.action=="talk" then
		--local lines={}
		
		--customnpcs[npc].lines[0][2]=customnpcs[npc].lines[0][2]:gsub("%name%",player(id,"name"))
		local function select(id,item)
			for _,ph in pairs(customnpcs[npc].lines[item[4]][2]) do
				ph=ph:gsub("%name%",player(id,"name"))
				msg2(id,customnpcs[npc].name..": "..ph)
			end
			local nextlines={}
			for _,d in pairs(item[5]) do
				nextlines[#nextlines+1]={customnpcs[npc].lines[d][1],"",select,d,customnpcs[npc].lines[d][3]}
				msg2(id,"[".._.."] "..customnpcs[npc].lines[d][1])
			end
			if #item[5]>0 then
				msg2(id,"[0] Goodbye.")
			end
			unimenu(id,true,{title="Talk",items=nextlines,modifiers="si"},1)
		end
		
		select(id,{customnpcs[npc].lines[0][1],"",select,0,customnpcs[npc].lines[0][3]})
		--unimenu(id,true,{title="Talk",items=lines,modifiers="si"},1)
	end
end

addhook("use","customnpcs.internal.use")
function customnpcs.internal.use(id)
	local x, y = player(id,"x"), player(id,"y")
	for _,npc in ipairs(customnpcs) do
		local nx, ny = npc.x*32+16, npc.y*32+16
		local dist = math.sqrt((nx-x)^2+(ny-y)^2)
		if dist<=npc.actionradius then
			customnpcs.internal.action(id,_)
		end
	end
end