items = {}
items.inventory = {}
items.invlimit = {}

items.internal = {}
items.internal.trading = {}
items.internal.cached = {}
items.internal.quickuse = {}

-- CONFIG --

items[0] = {"","",function() end}

-- FUNCTIONS --

--[[
items[iid]:

[1] - name
[2] - description
[3] - function
[4] - stackable

-----------

items.inventory[usgn]:

[1] - item id
[2] - stack number
]]

function items.internal.load(usgn)
	if (usgn~=0) then
		local fh=io.open("sys/lua/zombies/saves/"..usgn..".sav","r")
		if fh then
			local health,hunger,thirst,fatigue,rads,buffs,weapons,kills,rank,x,y,armour
			items.inventory[usgn],items.invlimit[usgn],health,hunger,thirst,fatigue,rads,kills,rank,x,y,armour,buffs,weapons=loadstring("return "..fh:read("*a"))()
			zombies.players[usgn].health=health
			zombies.players[usgn].hunger,zombies.players[usgn].thirst,zombies.players[usgn].fatigue=hunger,thirst,fatigue
			zombies.players[usgn].rads=rads
			zombies.players[usgn].buffs=buffs
			zombies.players[usgn].kills,zombies.players[usgn].rank=kills,rank
			zombies.players[usgn].spawnpos={x,y}
			zombies.players[usgn].weapons=weapons
			zombies.players[usgn].armour = armour
			fh:close()
		else
			items.inventory[usgn]=items.starterkit
			zombies.players[usgn].health = zombies.maxhealth
			zombies.players[usgn].hunger = zombies.maxhunger
			zombies.players[usgn].thirst = zombies.maxthirst
			zombies.players[usgn].fatigue = zombies.maxfatigue
			zombies.players[usgn].rads = 0
			zombies.players[usgn].buffs = {}
			zombies.players[usgn].kills = 0
			zombies.players[usgn].rank = 1
			zombies.players[usgn].weapons = {}
			zombies.players[usgn].armour = 0
			items.invlimit[usgn]=items.defaultlimit
			for i=#items.inventory[usgn]+1,items.invlimit[usgn] do
				items.inventory[usgn][i]={0}
				--print("setting "..i.." to 0")
			end
			items.internal.save(usgn)
		end
	end
end

function items.internal.save(usgn)
	if (usgn~=0) then
		local fh=io.open("sys/lua/zombies/saves/"..usgn..".sav","w")
		fh:write("{\n")
		for _,i in pairs(items.inventory[usgn]) do
			fh:write("{"..i[1])
			if i[2] then
				fh:write(","..i[2])
			end
			fh:write("},\n")
		end
		fh:write("},\n\n")
		fh:write(items.invlimit[usgn]..",")
		fh:write(zombies.players[usgn].health..",")
		fh:write(zombies.players[usgn].hunger..","..zombies.players[usgn].thirst..","..zombies.players[usgn].fatigue..",")
		fh:write(zombies.players[usgn].rads..",")
		fh:write(zombies.players[usgn].kills..",")
		fh:write(zombies.players[usgn].rank..",")
		fh:write(zombies.players[usgn].spawnpos[1]..","..zombies.players[usgn].spawnpos[2]..",")
		fh:write(zombies.players[usgn].armour)
		fh:write(",\n{")
		for _,i in pairs(zombies.players[usgn].buffs) do
			fh:write("{"..i[1])
			if i[2] then
				fh:write(","..i[2])
			end
			fh:write("},")
		end
		fh:write("},")
		fh:write("{"..table.concat(zombies.players[usgn].weapons,",").."}")
		fh:close()
	end
end

addhook("join","items.internal.join")
function items.internal.join(id)
	if not zombies.players[player(id,"usgn")] then zombies.players[player(id,"usgn")]={} end
	items.internal.load(player(id,"usgn"))
end

addhook("leave","items.internal.leave")
function items.internal.leave(id)
	zombies.players[player(id,"usgn")].spawnpos={player(id,"x"),player(id,"y")}
	items.internal.save(player(id,"usgn"))
end

function items.addItem(iid,name,description,func,stackable,stacksize)
	items[iid]={name,description,func,stackable,stacksize,[0]=iid}
end

function items.openInventory(id)
	local invitems={}
	for _,i in pairs(items.inventory[player(id,"usgn")]) do
		local function onclick(id,item)
			menu(id,"Actions,Use,Quick Use,(Drop|NOT IMPLEMENTED),(Trade|NOT IMPLEMENTED),"..(chests.nearChest(id) and "Put into chest" or ""))
			items.internal.cached[id] = {item[5]}
			if chests.nearChest(id) then items.internal.cached[id][2] = chests.nearChest(id) end
		end
		invitems[_]={items[i[1]][1],items[i[1]][2],onclick,_,i[1]}
		if i[2] and i[2]>1 then
			invitems[_][1]=invitems[_][1].." ("..i[2]..")"
		end
	end
	unimenu(id,true,{title="Inventory",items=invitems},1)
end

function items.nonFree(id)
	local nf=0
	for _,i in pairs(items.inventory[player(id,"usgn")]) do
		if i[1]~=0 then nf=nf+1 end
	end
	return nf
end

function items.freeInInventory(id)
	local fs=0
	if items.nonFree(id)<items.invlimit[player(id,"usgn")] then
		for _,i in pairs(items.inventory[player(id,"usgn")]) do
			if i[1]==0 then fs=fs+1 end
		end
	end
	return fs
end

function items.freeSlot(id)
	if items.nonFree(id)<items.invlimit[player(id,"usgn")] then
		for _,i in pairs(items.inventory[player(id,"usgn")]) do
			if i[1]==0 then return _ end
		end
	end
	return nil
end

function items.getAllItems(id,iid)
	local n = 0
	for _,i in pairs(items.inventory[player(id,"usgn")]) do
		if (i[1] == iid) then
			n = n + i[2]
		end
	end
	return n
end

function items.addToInventory(id,iid,n)
	
	if type(iid)=="string" then
		if iid:sub(1,4)=="cs2d" then
			for i = 1, n do
				parse("equip "..id.." "..iid:sub(6))
				table.insert(zombies.players[player(id,"usgn")].weapons,tonumber(iid:sub(6)))
			end
			return true
		end
	end
	
	n=n or 1
	for _,i in pairs(items.inventory[player(id,"usgn")]) do
		if i[1]==iid and i[2] and items[iid][4] and (items[iid][5] and i[2]+n<=items[iid][5] or true) then
			items.inventory[player(id,"usgn")][_][2]=items.inventory[player(id,"usgn")][_][2]+n
			return true
		end
	end
	
	--else
	
	local fs=items.freeInInventory(id)
	if n>1 and fs>=1 and items[iid][4] then
		if items[iid][5] and items[iid][5]>=n or true then
			local slot=items.freeSlot(id)
			items.inventory[player(id,"usgn")][slot]={iid,n}
			return true
		else
			local slot=items.freeSlot(id)
			items.inventory[player(id,"usgn")][slot]={iid,items[iid][5]}
			items.addToInventory(id,iid,n-items[iid][5])
		end
	end 
	if fs>=n then
		for i=1,n do
			local slot=items.freeSlot(id)
			if slot then
				items.inventory[player(id,"usgn")][slot]={iid}
				if items[iid][4] then
					items.inventory[player(id,"usgn")][slot][2]=1
				end
			else
				return false
			end
		end
		return true
	else
		return false
	end
	
	return false
end

function items.removeFromInventory(id,slot)
	items.inventory[player(id,"usgn")][slot]={0}
end

function items.removeItem(id,iid,n)
	
	if type(iid)=="string" then
		if iid:sub(1,4)=="cs2d" then
			for i = 1, n do
				parse("strip "..id.." "..iid:sub(6))
				table.removevalue(zombies.players[player(id,"usgn")].weapons,tonumber(iid:sub(6)))
			end
			return true
		end
	end
	
	n=n or 1
	for _,i in ipairs(items.inventory[player(id,"usgn")]) do
		if i[1]==iid then
			if i[2] then
				if i[2]>n then
					items.inventory[player(id,"usgn")][_][2]=items.inventory[player(id,"usgn")][_][2]-n
					return true
				else
					items.inventory[player(id,"usgn")][_]={0}
					if n-i[2]>0 then
						msg("removing "..n-i[2].." more")
						return items.removeItem(id,iid,n-i[2])
					else
						return true
					end
				end
			else
				if n>1 then
					for i=1,n do
						items.removeItem(id,iid)
					end
				else
					items.inventory[player(id,"usgn")][_]={0}
				end
				return true
			end
		end
	end
	return false
end

function items.clearInventory(id)
	for _,i in pairs(items.inventory[player(id,"usgn")]) do
		items.inventory[player(id,"usgn")][_]={0}
	end
end

function items.takeItems(id,itemtbl)
	local taken
	for _,i in pairs(itemtbl) do
		taken=items.removeItem(id,i[1],i[2])
		if not taken then return taken end
	end
	return taken
end

function items.giveItems(id,itemtbl)
	local added
	for _,i in pairs(itemtbl) do
		added=items.addToInventory(id,i[1],i[2])
		if not added then return added end
	end
	return added
end

function items.itemList(itemtbl)
	local listtext=""
	for _,t in pairs(itemtbl) do
		listtext = listtext..t[2].." of "..(type(t[1])~="string" and items[t[1]][1] or (t[1]:sub(1,4)=="cs2d" and itemtype(tonumber(t[1]:sub(6)),"name")))
		if _~=#itemtbl then
			listtext = listtext.." and "
		end
	end
	return listtext
end

addhook("menu","items.internal.actions")
function items.internal.actions(id,title,button)
	if (title=="Actions") then
		if (button==1) then
			items[items.internal.cached[id][1]][3](id,items.internal.cached[id][1])
			items.internal.cached[id] = nil
		end
		if (button==2) then
			items.internal.quickuse[id] = items.internal.cached[id][1]
			msg(items[items.internal.cached[id][1]][1].." has been placed into Quick Use. Press [F4] to use.")
		end
		if (button==5) then
			menu(id,"Put how many?,1,5,10,All")
		end
	end
	if (title=="Put how many?") then
		local tbl={[0]=0, 1, 5, 10, items.getAllItems(id,items.internal.cached[id][1])}
		if chests[items.internal.cached[id][2]][6]=="public" then
			chests.addItem(items.internal.cached[id][2],items.internal.cached[id][1],tbl[button])
			items.removeItem(id,items.internal.cached[id][1],tbl[button])
		else
			chests.addPrivateItem(items.internal.cached[id][2],items.internal.cached[id][1],tbl[button],id)
		end
		items.internal.cached[id] = nil
	end
end