monsters = {}
monsters.internal = {}
monsters.archetypes = {}
monsters.internal.monsters = {}

monsters.internal.speedfactor = 50

--- CONFIG ---



--- FUNCTIONS ---

function monsters.createArchetype(id,properties)
	monsters.archetypes[id]=properties
end

function monsters.setProperty(id,property,value)
	if monsters.archetypes[id] then
		monsters.archetypes[id][property]=value
	else
		print(string.char(169).."255200000LUA WARNING: Monster archetype "..id.." does not exist.")
	end
end

function monsters.spawnMonster(id,x,y,rot,properties)
	properties = properties or {}
	if monsters.archetypes[id] then
		table.insert(monsters.internal.monsters,{archetype=id,x=x,y=y,rot=rot})
		local cm=monsters.internal.monsters[#monsters.internal.monsters]
		cm.func=monsters.internal.main
		cm.pursuefunc=monsters.internal.pursue
		cm.pursuefunc2=monsters.internal.pursuez
		cm.fleefunc=monsters.internal.flee
		cm.attackfunc=monsters.internal.attack
		cm.roamfunc=monsters.internal.roam
		for pkey,prop in pairs(monsters.archetypes[id]) do
			cm[pkey]=prop
		end
		for pkey,prop in pairs(properties) do
			cm[pkey]=prop
		end
		--cm.thread = coroutine.create(monsters.internal.main)
		cm.img = image(cm.image,x,y,cm.imgmode or 1)
		if cm.behav and cm.behav:find("roam") then
			monsters.internal.roamint(#monsters.internal.monsters)
		end
		imagehitzone(cm.img,cm.hzmode or 104,-cm.hzox or 0,-cm.hzoy or 0,cm.hzox and cm.hzox*2 or 32,cm.hzoy and cm.hzoy*2 or 32)
	else
		print(string.char(169).."255200000LUA WARNING: Monster archetype "..id.." does not exist.")
	end
end

function monsters.removeMonster(mid)
	if monsters.internal.monsters[mid] then
		if monsters.internal.monsters[mid].img and monsters.internal.monsters[mid].img~=0 then
			freeimage(monsters.internal.monsters[mid].img)
		end
		if monsters.internal.monsters[mid].behav and monsters.internal.monsters[mid].behav:find("roam") then
			monsters.internal.roamf(mid)
		end
		table.remove(monsters.internal.monsters,mid)
	end
end

--- INTERNAL FUNCTIONS ---

function monsters.internal.main(m)
	--while true do
		--msg("processing monster")
		if m.health<=0 then
			freeimage(m.img)
			local mid=monsters.internal.monsterByTable(m)
			if mid then
				if m.deathfunc then m:deathfunc() end
				monsters.removeMonster(mid)
			end
			return 1
		end
		
		for _,p in pairs(player(0,"tableliving")) do
			local d=math.sqrt((player(p,"x")-m.x)^2+(player(p,"y")-m.y)^2)
			if m.behav and m.behav:find("flee") then
				--monsters.internal.flee(m,p)
				if m.reactdist and d<=m.reactdist then
					m.fleefunc(m,p)
					m.fleeing = true
				else
					m.fleeing = false
				end
			end
			if not m.target then
				if d<=m.reactdist then
					m.target = p
				end
			end
			--msg("dist: "..d)
		end
		if m.behav and m.behav:find("attack") and m.target then
			if player(m.target,"exists") then
				local d=math.sqrt((player(m.target,"x")-m.x)^2+(player(m.target,"y")-m.y)^2)
				if m.reactdist and d<=m.reactdist then
					--monsters.internal.pursue(m,p)
					m.pursuefunc(m,m.target)
					m.pursuing = true
				else
					m.pursuing = false
				end
			end
		end
		
		
		if m.behav and m.behav:find("defend") then
			for mid, mm in pairs(monsters.internal.monsters) do
				local d=math.sqrt((mm.x-m.x)^2+(mm.y-m.y)^2)
				--msg(tostring(not m.target).." and "..tostring(mm~=m).." and ("..tostring(m.ignore).." and "..tostring(not table.contains(m.ignore,mm.archetype)).." or true)")
				if not m.target and mm~=m and (m.ignore and not table.contains(m.ignore,mm.archetype) or (not m.ignore)) then
					--msg(d.."<="..m.reactdist)
					if d<=m.reactdist then
						m.target = mid
					end
				end
				--msg("dist: "..d)
			end
			
			if monsters.internal.monsters[m.target] then
				local mm = monsters.internal.monsters[m.target]
				local d=math.sqrt((mm.x-m.x)^2+(mm.y-m.y)^2)
				if m.reactdist and d<=m.reactdist then
					--monsters.internal.pursue(m,p)
					m.pursuefunc2(m,m.target)
					m.pursuing = true
				else
					m.pursuing = false
				end
			end
		end
		
		if m.behav and m.behav:find("roam") then
			if m.archetype==3 then
				--msg(tostring(m.roaming)..";"..tostring(m.patroling)..";"..tostring(m.pursuing)..";"..tostring(m.fleeing))
			end
			if m.roaming and not m.patroling and not m.pursuing or m.fleeing then
				m.roamfunc(m)
				m.roaming=true
			else
				m.roaming=false
			end
		end
		
		if m.behav and m.behav:find("patrol") then
			if m.patroling and not m.roaming and not m.pursuing or m.fleeing then
				m.patrolfunc(m)
			end
		end
		return 0
		--coroutine.yield()
	--end
end

-- ATTACK --

function monsters.internal.pursue(m,p)
	local d=math.sqrt((player(p,"x")-m.x)^2+(player(p,"y")-m.y)^2)
	--msg("rot: "..m.rot)
	if d>(m.atkdist or 1) then
		local x,y
		local fov=true
		if not m.nowiggle then
			m.trot = math.deg(math.atan2(player(p,"y")-m.y,player(p,"x")-m.x)-math.pi/2)
			if not m.rotdiff then m.rotdiff=0 end
			if not m.rotdiffdir then m.rotdiffdir=-1 end
			if not m.rotdifflim then m.rotdifflim=25 end
			m.rot = m.trot + m.rotdiff
			m.rotdiff = m.rotdiff + m.rotdiffdir
			if m.rotdiff>=m.rotdifflim or m.rotdiff<=-m.rotdifflim then
				m.rotdiffdir=-m.rotdiffdir
			end
			x,y=forward(m.x,m.y,m.trot,m.speed/50)
		else
			m.rot = math.deg(math.atan2(player(p,"y")-m.y,player(p,"x")-m.x)+math.pi/2)
			x,y=forward(m.x,m.y,m.rot,m.speed/50)
			local bx,by=forward(m.x,m.y,m.rot,i)
			bx,by=math.floor(bx/32),math.floor(by*32)
			if tile(tx,ty,"wall") then
				fov=false
			end
		end
		--local tx,ty=math.floor(x/32),math.floor(y/32)
		local tx,ty=forward(x,y,m.rot,24)
		tx,ty=math.floor(tx/32),math.floor(ty/32)
		local ctx,cty=math.floor(x/32),math.floor(y/32)
		--if tile(tx,ty,"walkable") then
		
		local function inSafeZones()
			for _, sz in pairs(zombies.safezones) do
				if coordsInBounds(tx,ty,sz) then
					return true
				end
			end
			return false
		end
		
		if tile(tx,ty,"walkable") and tile(ctx,cty,"walkable") and fov and (m.nosafe and not inSafeZones() or (not m.nosafe)) then
			m.x,m.y=x,y
			imagepos(m.img,x,y,m.rot+180)
		end
	else
		if m.atktimer==0 then
			monsters.internal.attack(m,p)
			m.atktimer = m.atktime or 1
		end
	end
end

function monsters.internal.pursuez(m,z)
	local mm = monsters.internal.monsters[z]
	local d=math.sqrt((mm.x-m.x)^2+(mm.y-m.y)^2)
	--msg("rot: "..m.rot)
	if d>(m.atkdist or 1) then
		local x,y
		local fov=true
		if not m.nowiggle then
			m.trot = math.deg(math.atan2(mm.y-m.y,mm.x-m.x)-math.pi/2)
			if not m.rotdiff then m.rotdiff=0 end
			if not m.rotdiffdir then m.rotdiffdir=-1 end
			if not m.rotdifflim then m.rotdifflim=25 end
			m.rot = m.trot + m.rotdiff
			m.rotdiff = m.rotdiff + m.rotdiffdir
			if m.rotdiff>=m.rotdifflim or m.rotdiff<=-m.rotdifflim then
				m.rotdiffdir=-m.rotdiffdir
			end
			x,y=forward(m.x,m.y,m.trot,m.speed/50)
		else
			m.rot = math.deg(math.atan2(mm.y-m.y,mm.x-m.x)+math.pi/2)
			x,y=forward(m.x,m.y,m.rot,m.speed/50)
			local bx,by=forward(m.x,m.y,m.rot,i)
			bx,by=math.floor(bx/32),math.floor(by*32)
			if tile(tx,ty,"wall") then
				fov=false
			end
		end
		--local tx,ty=math.floor(x/32),math.floor(y/32)
		local tx,ty=forward(x,y,m.rot,24)
		tx,ty=math.floor(tx/32),math.floor(ty/32)
		local ctx,cty=math.floor(x/32),math.floor(y/32)
		--if tile(tx,ty,"walkable") then
		
		local function inSafeZones()
			for _, sz in pairs(zombies.safezones) do
				if coordsInBounds(tx,ty,sz) then
					return true
				end
			end
			return false
		end
		
		if tile(tx,ty,"walkable") and tile(ctx,cty,"walkable") and fov and (m.nosafe and not inSafeZones() or (not m.nosafe)) then
			m.x,m.y=x,y
			imagepos(m.img,x,y,m.rot+180)
		end
	else
		if m.atktimer==0 then
			monsters.internal.attackz(m,z)
			m.atktimer = m.atktime or 1
		end
	end
end

function monsters.internal.attack(m,p)
	local rot=m.rot
	if rot<180 then rot=rot+180 end
	--msg("rot: "..rot)
	tween_rotate(m.img,100,rot+45)
	--msg("rot+45: "..rot+45)
	timer(100,"parse","lua tween_rotate("..m.img..",200,"..rot..")")
	local swingimg = image("gfx/knifeslash.bmp",m.x,m.y,1)
	imagepos(swingimg,m.x,m.y,m.rot-180)
	imageblend(swingimg,1)
	imagealpha(swingimg,0)
	tween_alpha(swingimg,100,1)
	timer(100,"parse","lua tween_alpha("..swingimg..",100,0)")
	timer(200,"parse","lua freeimage("..swingimg..")")
	if not zombies.players[player(p,"usgn")].safe then
		m.dmgfunc(p,m.dmg)
	end
end

function monsters.internal.attackz(m,z)
	local mm = monsters.internal.monsters[z]
	local rot=m.rot
	if rot<180 then rot=rot+180 end
	--msg("rot: "..rot)
	tween_rotate(m.img,100,rot+45)
	--msg("rot+45: "..rot+45)
	timer(100,"parse","lua tween_rotate("..m.img..",200,"..rot..")")
	local swingimg = image("gfx/knifeslash.bmp",m.x,m.y,1)
	imagepos(swingimg,m.x,m.y,m.rot-180)
	imageblend(swingimg,1)
	imagealpha(swingimg,0)
	tween_alpha(swingimg,100,1)
	timer(100,"parse","lua tween_alpha("..swingimg..",100,0)")
	timer(200,"parse","lua freeimage("..swingimg..")")
	mm.health=mm.health-m.dmg
	if mm.health<=0 then
		if mm.killfunc then mm:killfunc(p) end
		monsters.removeMonster(z)
	end
end

-- FLEE --

function monsters.internal.flee(m,p)
	--[[local x,y=forward(m.x,m.y,m.rot,m.speed/50)
	local tx,ty=forward(x,y,m.rot,24)]]
	if not m.nowiggle then
		m.trot = math.deg(math.atan2(player(p,"y")-m.y,player(p,"x")-m.x)+math.pi/2)
		if not m.rotdiff then m.rotdiff=0 end
		if not m.rotdiffdir then m.rotdiffdir=-1 end
		if not m.rotdifflim then m.rotdifflim=25 end
		m.rot = m.trot + m.rotdiff
		m.rotdiff = m.rotdiff + m.rotdiffdir
		if m.rotdiff>=m.rotdifflim or m.rotdiff<=-m.rotdifflim then
			m.rotdiffdir=-m.rotdiffdir
		end
		x,y=forward(m.x,m.y,m.trot,m.speed/50)
		tx,ty=forward(x,y,m.trot,32)
	else
		m.rot = math.deg(math.atan2(player(p,"y")-m.y,player(p,"x")-m.x)+math.pi/2)
		x,y=forward(m.x,m.y,m.rot,m.speed/50)
		tx,ty=forward(x,y,m.rot,32)
	end
	tx,ty=math.floor(tx/32),math.floor(ty/32)
	local ctx,cty=math.floor(x/32),math.floor(y/32)
	
	local function inSafeZones()
		for _, sz in pairs(zombies.safezones) do
			if coordsInBounds(tx,ty,sz) then
				return true
			end
		end
		return false
	end
	
	if tile(tx,ty,"walkable") and tile(ctx,cty,"walkable") and (m.nosafe and not inSafeZones() or (not m.nosafe)) then
		m.x,m.y=x,y
		imagepos(m.img,x,y,m.rot-180)
	end
	return 
end

-- ROAM --

function monsters.internal.roam(m)
	local x,y,tx,ty
	if not m.nowiggle then
		if not m.rotdiff then m.rotdiff=0 end
		if not m.rotdiffdir then m.rotdiffdir=-1 end
		if not m.rotdifflim then m.rotdifflim=25 end
		m.rot = m.trot + m.rotdiff
		m.rotdiff = m.rotdiff + m.rotdiffdir
		if m.rotdiff>=m.rotdifflim or m.rotdiff<=-m.rotdifflim then
			m.rotdiffdir=-m.rotdiffdir
		end
		x,y=forward(m.x,m.y,m.trot,m.speed/50)
		tx,ty=forward(x,y,m.trot,32)
	else
		x,y=forward(m.x,m.y,m.rot,m.speed/50)
		tx,ty=forward(x,y,m.rot,32)
	end
	tx,ty=math.floor(tx/32),math.floor(ty/32)
	local ctx,cty=math.floor(x/32),math.floor(y/32)
	
	local function inSafeZones()
		for _, sz in pairs(zombies.safezones) do
			if coordsInBounds(tx,ty,sz) then
				return true
			end
		end
		return false
	end
	
	if tile(tx,ty,"walkable") and tile(ctx,cty,"walkable") and (m.nosafe and not inSafeZones() or (not m.nosafe)) then
		m.x,m.y=x,y
		imagepos(m.img,x,y,m.rot-180)
	end
end

function monsters.internal.roamint(mid)
	local m=monsters.internal.monsters[mid]
	if m then
		if not m.pursuing and not m.fleeing then
			if not m.nowiggle then
				m.trot = math.random(0,360)
				tween_rotate(m.img,200,m.trot-180)
			else
				m.rot = math.random(0,360)
				tween_rotate(m.img,200,m.rot-180)
			end
			m.roaming = false
			if not m.roamtimer then m.roamtimer=m.roamtime or 5 end
			if not m.roamingtimer then m.roamingtimer=math.random(m.minroam or 1,m.maxroam or 3) end
			timer(m.roamtimer*1000,"parse","lua \"if(monsters.internal.monsters["..mid.."])then monsters.internal.monsters["..mid.."].roaming=true end\"")
		end
		timer(m.roamtimer*1000,"parse","lua \"timer("..m.roamingtimer*1000 ..",'parse','lua monsters.internal.roamint("..mid..")')\"")	
	end
end

function monsters.internal.roamf(mid)
	local m=monsters.internal.monsters[mid]
	if m then
		freetimer("parse","lua \"if(monsters.internal.monsters["..mid.."])then monsters.internal.monsters["..mid.."].roaming=true end\"")
		freetimer("parse","lua \"timer("..m.roamingtimer*1000 ..",'parse','monsters.internal.roamint("..mid..")'\"")
	end
end

-- PATROL --

-- OTHER --

function monsters.internal.monsterByTable(m)
	for _,mt in pairs(monsters.internal.monsters) do
		if mt==m then
			return _
		end
	end
	return nil
end

function monsters.internal.monsterByImg(img)
	for _,m in pairs(monsters.internal.monsters) do
		if m.img==img then
			return _
		end
	end
	return nil
end

function monsters.internal.action(id,npc)
	local enpc=monsters.internal.monsters[npc]
	if enpc.action=="trade" then
		local tritems={}
		for _,bar in pairs(customnpcs[npc].trade) do
			local function trade(id,item)
				local fs = items.freeInInventory(id)
				local ts = 0
				for _,t in pairs(bar[2]) do
					ts=ts+t[2]
				end
				if fs>=ts then
					local taken=items.takeItems(id,bar[1])
					if taken then
						local added=items.giveItems(id,bar[2])
						if added then
							msg2(id,"Trade successful!")
						end
					else
						msg2(id,"Trade failed! You do not have enough to pay.")
					end
				else
					msg2(id,"Trade failed! You don't have enough space.")
				end
				unimenu(id,"old")
			end
			--local tradetext = ""
			--for _,t in pairs(bar[1]) do
			--	tradetext = tradetext..t[2].." of "..items[t[1]][1]
			--	if _~=#bar[1] then
			--		tradetext = tradetext.." and "
			--	end
			--end
			tradetext=items.itemList(bar[1]).." for "..items.itemList(bar[2])
			--tradetext = tradetext.." for "
			--for _,t in pairs(bar[2]) do
			--	tradetext = tradetext..t[2].." of "..items[t[1]][1]
			--	if _<#bar[2] then
			--		tradetext = tradetext.." and "
			--	end
			--end
			tritems[#tritems+1]={tradetext,"",trade,bar[1],bar[2]}
		end
		unimenu(id,true,{title="Trade with "..customnpcs[npc].name,items=tritems},1)
	end
	--modifiers
	if enpc.action=="talk" then
		--local lines={}
		
		--customnpcs[npc].lines[0][2]=customnpcs[npc].lines[0][2]:gsub("%name%",player(id,"name"))
		local function select(id,item)
			for _,ph in pairs(customnpcs[npc].lines[item[4]][2]) do
				ph=ph:gsub("%name%",player(id,"name"))
				msg2(id,customnpcs[npc].name..": "..ph)
			end
			local nextlines={}
			for _,d in pairs(item[5]) do
				nextlines[#nextlines+1]={customnpcs[npc].lines[d][1],"",select,d,customnpcs[npc].lines[d][3]}
				msg2(id,"[".._.."] "..customnpcs[npc].lines[d][1])
			end
			if #item[5]>0 then
				msg2(id,"[0] Goodbye.")
			end
			unimenu(id,true,{title="Talk",items=nextlines,modifiers="si"},1)
		end
		
		select(id,{customnpcs[npc].lines[0][1],"",select,0,customnpcs[npc].lines[0][3]})
		--unimenu(id,true,{title="Talk",items=lines,modifiers="si"},1)
	end
end

addhook("hitzone","monsters.internal.hitzone")
function monsters.internal.hitzone(img,p,oid,w,x,y)
	local mid=monsters.internal.monsterByImg(img)
	--msg("hitimg: "..img)
	--msg("mid: "..mid)
	--msg("health: "..monsters.internal.monsters[mid].health)
	if mid then
		--if not zombies.players[player(p,"usgn")].safe then
			local m=monsters.internal.monsters[mid]
			m.health=m.health-itemtype(w,"dmg")
			if m.health<=0 then
				if m.killfunc then m:killfunc(p) end
				monsters.removeMonster(mid)
			end
		--end
	end
end

addhook("always","monsters.internal.always")
function monsters.internal.always()
	for _,m in pairs(monsters.internal.monsters) do
		--[[if m.thread and coroutine.status(m.thread)~="dead" then
			--local exec,err = coroutine.resume(m.thread,m)
			resumes=resumes+1
		end]]
		monsters.internal.main(m)
	end
end

addhook("ms100","monsters.internal.ms100")
function monsters.internal.ms100()
	for _,m in pairs(monsters.internal.monsters) do
		if m.behav and m.behav:find("attack") then
			if not m.atktimer then m.atktimer=0 end
			if m.atktimer>0 then m.atktimer=m.atktimer-0.1 end
			if m.atktimer<=0 then m.atktimer=0 end
		end
		--[[if m.behav and m.behav:find("roam") then
			if not m.roamtimer then m.roamtimer=0 end
			if not m.roaming then m.roaming=false end
			if not m.roamingtimer then m.roamingtimer=0 end
			if m.roamtimer>0 then m.roamtimer=m.roamtimer-0.1 end
			if m.roamtimer<=0 then m.roamtimer=nil m.roamingtimer=math.random(m.minroam or 1,m.maxroam or 3) end
			if m.roamingtimer>0 then m.roamingtimer=m.roamingtimer-0.1 end
			if m.roamingtimer<=0 then m.roamingtimer=nil m.roamtimer=m.roamtime or 5 end
		end]]
	end
end

addhook("startround","monsters.internal.startround")
function monsters.internal.startround()
	for m, _ in pairs(monsters.internal.monsters) do
		monsters.removeMonster(m)
	end
end