towns = {}
towns.internal = {}
towns.internal.towns = {}
towns.internal.intown = {}
towns.internal.plotocc = {}
towns.internal.onplot = {}
towns.internal.invited = {}

--- CONFIG ---


--- FUNCTIONS ---

function towns.internal.load()
	local fh=io.open("sys/lua/zombies/saves/towns/metatowns.sav","r")
	local townids={}
	if fh then
		townids = loadstring("return {"..fh:read("*a").."}")()
		fh:close()
	end
	for _,t in pairs(townids) do
		fh=io.open("sys/lua/zombies/saves/towns/town"..t..".sav","r")
		if fh then
			towns.internal.towns[t] = loadstring("return "..fh:read("*a"))()
			towns.internal.plotocc[towns.internal.towns[t].plot] = true
			for _,b in pairs(towns.internal.towns[t].buildings) do
				parse("spawnobject "..b[1].." "..b[2].." "..b[3].." 0 0 0")
			end
			--print(towns.internal.towns[t].name.." loaded")
			fh:close()
			return true
		end
		return false
	end
end

towns.internal.load()

function towns.internal.save(tid)
	local fh=io.open("sys/lua/zombies/saves/towns/town"..tid..".sav","w")
	local t=towns.internal.towns[tid]
	
	fh:write("{\n")
	
	fh:write("\tplot = "..t.plot..",\n")
	fh:write("\tname = \""..t.name.."\",\n")
	fh:write("\towner = "..t.owner..",\n")
	fh:write("\tmembers = {"..table.concat(t.members,",").."},\n")
	fh:write("\tbuildings = {\n")
	
	for _,b in pairs(t.buildings) do
		fh:write("\t\t{"..table.concat(b,",").."},\n")
	end
	
	fh:write("\t},\n")
	fh:write("\tproperties = {\n")
	
	for k,p in pairs(t.properties) do
		fh:write("\t\t"..k.." = "..p.."\n")
	end
	
	fh:write("\t}")
	
	fh:write("\n}")
	fh:close()
	
	fh=io.open("sys/lua/zombies/saves/towns/metatowns.sav","a+")
	if not fh:read("*a"):find(tostring(tid)) then
		fh:write(tid..",")
	end
	fh:close()
end

function towns.createTown(plot,owner,name,properties)
	towns.internal.towns[#towns.internal.towns+1] = {plot=plot,owner=owner,name=name,members={},buildings={},properties=properties or {}}
	towns.internal.plotocc[plot]=true
	towns.internal.save(#towns.internal.towns)
	return #towns.internal.towns
end

function towns.setProperty(town,property,value)
	towns.internal.towns[town][property]=value
	if property=="safezone" then
		if value==true then
			zombies.safezones[#zombies.safezones+1]=towns.internal.towns[town].boundaries
		else
			for _,sz in pairs(zombies.safezones) do
				if sz==towns.internal.towns[town].boundaries then
					table.remove(zombies.safezones,_)
				end
			end
		end
	end
	if property=="cover" then
		if value==true then
			zombies.cover[#zombies.cover+1]=towns.internal.towns[town].boundaries
		else
			for _,sz in pairs(zombies.cover) do
				if sz==towns.internal.towns[town].boundaries then
					table.remove(zombies.cover,_)
				end
			end
		end
	end
	towns.internal.save(town)
end

function towns.getInTown(id,town)
	if towns.internal.towns[town].owner == player(id,"usgn") then return true end
	for k,v in pairs(towns.internal.towns[town].members) do
		if v == player(id,"usgn") then
			return true
		end
	end
	return false
end

function towns.isMember(id,town)
	for k,v in pairs(towns.internal.towns[town].members) do
		if v == player(id,"usgn") then
			return true
		end
	end
	return false
end

function towns.getTown(id)
	for tid, t in pairs(towns.internal.towns) do
		if t.owner == player(id,"usgn") then return tid end
		for k,v in pairs(t.members) do
			if v == player(id,"usgn") then
				return tid
			end
		end
	end
	return 0
end

function towns.getOwner(town)
	return towns.internal.towns[town].owner
end

function towns.getProperty(town,property)
	return towns.internal.towns[town].properties[property]
end

addhook("buildattempt","towns.internal.buildattempt")
function towns.internal.buildattempt(id,type,x,y,mode)
	msg(#towns.internal.towns)
	for tid,town in pairs(towns.internal.towns) do
		--x>=town.boundaries[1] and y>=town.boundaries[2] and x<=town.boundaries[3] and y<=town.boundaries[4]
		if coordsInBounds(x,y,towns.plots[town.plot]) then
			--msg(tostring((town.properties.membersbuild and town.members[player(id,"usgn")] and (town.properties.buildrank and town.members[player(id,"usgn")]==town.properties.buildrank or true)) or town.owner==player(id,"usgn")))
			if (town.properties.membersbuild and town.members[player(id,"usgn")] and (town.properties.buildrank and town.members[player(id,"usgn")]==town.properties.buildrank or true)) or town.owner==player(id,"usgn") then
				if type<6 then
					parse("spawnobject "..type.." "..x.." "..y.." "..mode.." "..player(id,"team").." "..id)
					msg(mode)
					town.buildings[#town.buildings+1]={type,x,y,player(id,"usgn")}
					towns.internal.save(tid)
				end
				return 1
			else
				if not town.members[player(id,"usgn")] then
					msg2(id,"You are not a member of "..town.name.."!")
				end
			end
		end
	end
end

addhook("objectdamage","towns.internal.objectdamage")
function towns.internal.objectdamage(oid,dmg,id)
	for tid,town in pairs(towns.internal.towns) do
		for _,b in pairs(town.buildings) do
			if object(oid,"tilex")==b[2] and object(oid,"tiley")==b[3] and object(oid,"type")==b[1] then
				if (town.properties.memberdestroy and town.members[player(id,"usgn")] or true) or town.owner==player(id,"usgn") then
					-- do nothing
				else
					return 1
				end
			end
		end
	end
end

addhook("objectkill","towns.internal.objectkill")
function towns.internal.objectkill(oid,id)
	for tid,town in pairs(towns.internal.towns) do
		for _,b in pairs(town.buildings) do
			if object(oid,"tilex")==b[2] and object(oid,"tiley")==b[3] and object(oid,"type")==b[1] then
				table.remove(town.buildings,_)
				towns.internal.save(tid)
			end
		end
	end
end

addhook("movetile","towns.internal.movetile")
function towns.internal.movetile(id,x,y)
	if towns.plots and #towns.plots>0 then
		for tid,town in pairs(towns.internal.towns) do
			--x>=town.boundaries[1] and y>=town.boundaries[2] and x<=town.boundaries[3] and y<=town.boundaries[4]
			if coordsInBounds(x,y,towns.plots[town.plot]) then
				if not towns.internal.intown[id] then
					msg2(id,"You are now entering "..string.char(169).."000200000"..town.name..string.char(169).."255220000, population "..string.char(169).."000200000"..#town.members+1)
					towns.internal.intown[id] = true
					break
				end
			else
				if towns.internal.intown[id] then towns.internal.intown[id] = false end
			end
		end
		for pid,plot in pairs(towns.plots) do
			--x>=town.boundaries[1] and y>=town.boundaries[2] and x<=town.boundaries[3] and y<=town.boundaries[4]
			if coordsInBounds(x,y,plot) then
				if not towns.internal.onplot[id] and not towns.internal.plotocc[pid] then
					msg2(id,"This is a plot available for purchase.")
					towns.internal.onplot[id] = pid
					break
				end
			else
				if towns.internal.onplot[id] then towns.internal.onplot[id] = false end
			end
		end
	end
end