buildingnames = {"Barricade","Barbed Wire","Wall I","Wall II","Wall III"}

function table.contains(tbl,el)
	for k,v in pairs(tbl) do
		if v==el then
			return true,k
		end
	end
end

function playerFromUSGN(usgn)
	for _,id in pairs(player(0,"table")) do
		if player(id,"usgn")==usgn then
			return player(id,"name")
		end
	end
	return usgn
end

function coordsInBounds(x,y,boundaries)
	if x>=boundaries[1] and y>=boundaries[2] and x<=boundaries[3] and y<=boundaries[4] then
		return true
	end
	return false
end

function string.split(str,pat)
	pat = pat or "[^%s]+"
	local t = {}
	for w in string.gmatch(str,pat) do
		t[#t+1]=w
	end
	return t
end

function forward(x,y,rot,factor)
	local angle=math.rad(rot+90)
	local cx=x+(math.cos(angle)*factor)
	local cy=y+(math.sin(angle)*factor)
	return cx,cy
end

function table.removevalue(tbl,val,del)
	for k,v in pairs(tbl) do
		if v==val then
			if not del then
				table.remove(tbl,k)
			else
				tbl[k] = nil
			end
		end
	end
end

function toboolean(v)
	if v=="true" or v==1 then return true end
	if v=="false" or v==0 then return false end
	return nil
end

function table.copy(t)
	local tt = {}
	for k,v in pairs(t) do
		tt[k] = v
	end
	return tt
end

function round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

function stepAngle(angle, step)
	local d = round(angle/step,0)
	print(d)
	return step*d
end